function Calc_Comp_methods(opt)


if ~isfield(opt,'get_data'); error('data loading function missing get_data(opt,i)'); end
if ~isfield(opt,'get_filename'); error('filename function missing get_filename(opt)'); end

if ~isfield(opt,'nbloop'); opt.nbloop=1; end
if ~isfield(opt,'seed'); opt.seed=1; end
if ~isfield(opt,'remtime'); opt.remtime=0; end
if ~isfield(opt,'mremtime'); opt.mremtime=0; end


nbloop=opt.nbloop;


seed=opt.seed;
rand('seed',seed);
randn('seed',seed);

filename_s=opt.get_filename(opt);

if opt.remtime
%     if opt.mremtime
%         multi_remtime(filename_s,opt.mremtime,0,nbloop)
%     else
        remtime(filename_s,0,'Start');
%     end
end

nbtodomax=10;

todo=opt.todo;

if length(todo)<nbtodomax
       todo=[todo zeros(1,nbtodomax-length(todo))];
    
end


resfilename=['results/' filename_s '.mat'];
diafilename=['results/' filename_s  '.log'];

opt_s=opt;

diary(diafilename)
diary on

criterions=opt.criterions;

% validatino vectors
Cvec=opt.Cvec;
Cvec2=opt.Cvec2;
qvec=opt.qvec;
Cvecxdawn=opt.Cvecxdawn;
Cveclda=opt.Cveclda;

disp(['Filename : ' filename_s])

%% loop

for i=1:nbloop
    %% initialisation
    disp(['Loop: ' num2str(i)])

    [X,Y,Xte,Yte,info]=opt.get_data(opt,i);
    
    [X,Xte,meanxapp_s,stdxapp_s] = normalizemeanstd(X,Xte);
    
    
    [indice]=GetDataAppTestIdx(X,Y,round(opt.nbtrain*opt.ratiocv),opt.nbcv);
    
    optval=[];
    
    optval.indice=indice;
    optval.nbloop=opt.nbcv;
    optval.criterions=criterions;
    optval.use_idx=1;
    optval.keeplog=1;
    
    
    %% svm standard
    if todo(1)==1
        disp('Standard SVM')

        optv=optval;

        % validation options
        optv.params{1}='C';
        optv.values{1}=Cvec;
        
        optv.learning=@svmclass2;
        optv.valmodels=@svmval2;
        
        [svm_s{i},options_svm_s{i},LOG_s{i}]=cross_validation_loop(X,Y,opt.options_svm,optv);
        
        Ypred=svmval2(Xte,svm_s{i});
        prec_svm_s(i)=get_precision(Yte , Ypred);
        
        acc_svm_s(i)=prec_svm_s(i).prec;
        auc_svm_s(i)=prec_svm_s(i).auc;
        sel_svm_s(i)=get_group_sparsity(svm_s{i},opt);
        time_svm_s(i)=LOG_s{i}.time;

        m_acc_svm_s=mean(acc_svm_s);
        m_auc_svm_s=mean(auc_svm_s);  
        
        fprintf('| Acc      | Auc       |\n')
        fprintf('| %1.6f | %1.6f |\n',acc_svm_s(i),auc_svm_s(i))

    end
    
    
    %% svn l1
    if todo(2)==1
        disp('SVM l1')

        optv=optval;

        % validation options
        optv.params{1}='C';
        optv.values{1}=Cvec2;
        
        optv.learning=@glgroupsvmclass;
        optv.valmodels=@svmval2;
        
        % svm options
        options_glsvm=opt.options_glsvm;
        options_glsvm.norm=1;
        
        [svm1_s{i},options_svm1_s{i},LOG1_s{i}]=cross_validation_loop(X,Y,options_glsvm,optv);
        
        Ypred=svmval2(Xte,svm1_s{i});
        prec_svm1_s(i)=get_precision(Yte , Ypred);
        
        acc_svm1_s(i)=prec_svm1_s(i).prec;
        auc_svm1_s(i)=prec_svm1_s(i).auc;
        sel_svm1_s(i)=get_group_sparsity(svm1_s{i},opt);
        time_svm1_s(i)=LOG1_s{i}.time;
        
        m_acc_svm1_s=mean(acc_svm1_s);
        m_auc_svm1_s=mean(auc_svm1_s);  
        
        fprintf('| Acc      | Auc       |\n')
        fprintf('| %1.6f | %1.6f |\n',acc_svm1_s(i),auc_svm1_s(i))

    end
    
    %% Gsvn l2
    if todo(3)==1
        
        disp('GSVM l2')

        optv=optval;

        % validation options
        optv.params{1}='C';
        optv.values{1}=Cvec2;
        
        optv.learning=@glgroupsvmclass;
        optv.valmodels=@svmval2;
        
        % svm options
        options_glsvm=opt.options_glsvm;
        options_glsvm.norm=2;
        
        [gsvm2_s{i},options_gsvm2_s{i},LOGg2_s{i}]=cross_validation_loop(X,Y,options_glsvm,optv);
        
        Ypred=svmval2(Xte,gsvm2_s{i});
        prec_gsvm2_s(i)=get_precision(Yte , Ypred);
        
        acc_gsvm2_s(i)=prec_gsvm2_s(i).prec;
        auc_gsvm2_s(i)=prec_gsvm2_s(i).auc;
        sel_gsvm2_s(i)=get_group_sparsity(gsvm2_s{i},opt);
        time_gsvm2_s(i)=LOGg2_s{i}.time;
        
        m_acc_gsvm2_s=mean(acc_gsvm2_s);
        m_auc_gsvm2_s=mean(auc_gsvm2_s);  
        
        fprintf('| Acc      | Auc       |\n')
        fprintf('| %1.6f | %1.6f |\n',acc_gsvm2_s(i),auc_gsvm2_s(i))

    end    
    
    
        %% Gsvn linf
    if todo(4)==1
        
        disp('GSVM l-Inf')

        optv=optval;

        % validation options
        optv.params{1}='C';
        optv.values{1}=Cvec2; 
        
        
        optv.learning=@glgroupsvmclass;
        optv.valmodels=@svmval2;
        
        % svm options
        options_glsvm=opt.options_glsvm;
        options_glsvm.norm=Inf;
        
        [gsvmi_s{i},options_gsvmi_s{i},LOGgi_s{i}]=cross_validation_loop(X,Y,options_glsvm,optv);
        
        Ypred=svmval2(Xte,gsvmi_s{i});
        prec_gsvmi_s(i)=get_precision(Yte , Ypred);
        
        acc_gsvmi_s(i)=prec_gsvmi_s(i).prec;
        auc_gsvmi_s(i)=prec_gsvmi_s(i).auc;
        sel_gsvmi_s(i)=get_group_sparsity(gsvmi_s{i},opt);
        time_gsvmi_s(i)=LOGgi_s{i}.time;
        
        m_acc_gsvmi_s=mean(acc_gsvmi_s);
        m_auc_gsvmi_s=mean(auc_gsvmi_s);  
        
        fprintf('| Acc      | Auc       |\n')
        fprintf('| %1.6f | %1.6f |\n',acc_gsvmi_s(i),auc_gsvmi_s(i))

    end      
    
    %% Gsvn lp
    if todo(5)==1
        
        disp('GSVM l-p')

        optv=optval;

        % validation options
        optv.params{1}='C';
        optv.values{1}=Cvec2;
        
        optv.params{2}='norm';
        optv.values{2}=qvec;      
        
        
        optv.learning=@glgroupsvmclass;
        optv.valmodels=@svmval2;
        
        % svm options
        options_glsvm=opt.options_glsvm;
        options_glsvm.norm=2;
        
        [gsvmp_s{i},options_gsvmp_s{i},LOGgp_s{i}]=cross_validation_loop(X,Y,options_glsvm,optv);
        
        Ypred=svmval2(Xte,gsvmp_s{i});
        prec_gsvmp_s(i)=get_precision(Yte , Ypred);
        
        acc_gsvmp_s(i)=prec_gsvmp_s(i).prec;
        auc_gsvmp_s(i)=prec_gsvmp_s(i).auc;
        sel_gsvmp_s(i)=get_group_sparsity(gsvmp_s{i},opt);
        time_gsvmp_s(i)=LOGgp_s{i}.time;
        
        m_acc_gsvmp_s=mean(acc_gsvmp_s);
        m_auc_gsvmp_s=mean(auc_gsvmp_s);  
        
        fprintf('| Acc      | Auc       |\n')
        fprintf('| %1.6f | %1.6f |\n',acc_gsvmp_s(i),auc_gsvmp_s(i))

    end      
    
      %% Adaptive lasso
    if todo(6)==1
        
        disp('GSVM adaptive')

        optv=optval;

        % validation options
        optv.params{1}='C';
        if ~isfield(opt,'Cveca')
        optv.values{1}=Cvec2;
        else
           optv.values{1}=opt.Cveca;
        end
        
        %optv.params{2}='norm';
        %optv.values{2}=qvec;      
        
        
        optv.learning=@algroupsvmclass;
        optv.valmodels=@svmval2;
        
        % svm options
        options_glsvm=opt.options_alsvm;
        options_glsvm.norm=2;
        
        [gsvma_s{i},options_gsvma_s{i},LOGga_s{i}]=cross_validation_loop(X,Y,options_glsvm,optv);
        
        Ypred=svmval2(Xte,gsvma_s{i});
        prec_gsvma_s(i)=get_precision(Yte , Ypred);
        
        acc_gsvma_s(i)=prec_gsvma_s(i).prec;
        auc_gsvma_s(i)=prec_gsvma_s(i).auc;
        sel_gsvma_s(i)=get_group_sparsity(gsvma_s{i},opt);
        time_gsvma_s(i)=LOGga_s{i}.time;
        
        m_acc_gsvma_s=mean(acc_gsvma_s);
        m_auc_gsvma_s=mean(auc_gsvma_s);  
        
        fprintf('| Acc      | Auc       |\n')
        fprintf('| %1.6f | %1.6f |\n',acc_gsvma_s(i),auc_gsvma_s(i))

    end    
    
    %% lda standard
    if todo(7)==1
        disp('Standard LDA')

        optv=optval;
        
        optlda=opt.options_svm;
        optlda.prob=1;
        

        % validation options
        optv.params{1}='C';
        optv.values{1}=Cveclda;
        
        optv.learning=@svmclass2;
        optv.valmodels=@svmval2;
        
        [lda_s{i},options_lda_s{i},LOG_lda_s{i}]=cross_validation_loop(X,Y,optlda,optv);
        
        Ypred=svmval2(Xte,lda_s{i});
        prec_lda_s(i)=get_precision(Yte , Ypred);
        
        acc_lda_s(i)=prec_lda_s(i).prec;
        auc_lda_s(i)=prec_lda_s(i).auc;
        sel_lda_s(i)=get_group_sparsity(lda_s{i},opt);
        time_lda_s(i)=LOG_lda_s{i}.time;

        m_acc_lda_s=mean(acc_lda_s);
        m_auc_lda_s=mean(auc_lda_s);  
        
        fprintf('| Acc      | Auc       |\n')
        fprintf('| %1.6f | %1.6f |\n',acc_lda_s(i),auc_lda_s(i))

    end
        
    %% lda xDAWN
    if todo(8)==1
        disp('xDAWN LDA')

        optv=optval;
        
        optlda=opt.options_svm;
        optlda.prob=1;
        optlda.U=info.U;
        

        % validation options
        optv.params{1}='C';
        optv.values{1}=Cvecxdawn;
        
        optv.params{2}='nbkeep';
        optv.values{2}=opt.nbkeepvec;
        
        optv.learning=@xdawnclass;
        optv.valmodels=@svmval2;
        
        [xlda_s{i},options_xlda_s{i},LOG_xlda_s{i}]=cross_validation_loop(X,Y,optlda,optv);
        
        Ypred=svmval2(Xte,xlda_s{i});
        prec_xlda_s(i)=get_precision(Yte , Ypred);
        
        acc_xlda_s(i)=prec_xlda_s(i).prec;
        auc_xlda_s(i)=prec_xlda_s(i).auc;
        sel_xlda_s(i)=get_group_sparsity(xlda_s{i},opt);
        time_xlda_s(i)=LOG_xlda_s{i}.time;

        m_acc_xlda_s=mean(acc_xlda_s);
        m_auc_xlda_s=mean(auc_xlda_s);  
        
        fprintf('| Acc      | Auc       |\n')
        fprintf('| %1.6f | %1.6f |\n',acc_xlda_s(i),auc_xlda_s(i))

    end    
    
    
        %% Gsvn trace norm
    if todo(9)==1
        
        disp('GSVM trace')

        optv=optval;

        % validation options
        optv.params{1}='C';
        optv.values{1}=Cvec2;
        
        optv.learning=@glgroupsvmclass;
        optv.valmodels=@svmval2;
        
        % svm options
        options_glsvm=opt.options_glsvm;
        options_glsvm.norm='trace';
        
        [gsvmt_s{i},options_gsvmt_s{i},LOGgt_s{i}]=cross_validation_loop(X,Y,options_glsvm,optv);
        
        Ypred=svmval2(Xte,gsvmt_s{i});
        prec_gsvmt_s(i)=get_precision(Yte , Ypred);
        
        acc_gsvmt_s(i)=prec_gsvmt_s(i).prec;
        auc_gsvmt_s(i)=prec_gsvmt_s(i).auc;
        sel_gsvmt_s(i)=get_group_sparsity(gsvmt_s{i},opt);
        time_gsvmt_s(i)=LOGgt_s{i}.time;
        
        m_acc_gsvmt_s=mean(acc_gsvmt_s);
        m_auc_gsvmt_s=mean(auc_gsvmt_s);  
        
        fprintf('| Acc      | Auc       |\n')
        fprintf('| %1.6f | %1.6f |\n',acc_gsvmt_s(i),auc_gsvmt_s(i))

    end    
    
    
    %% print loop stats
    fprintf(['Loop' num2str(i) ' stats:\n'])
    fprintf('|Method    |Test ACC  | AUC      |\n')
    fprintf('-------------------------------------\n')
    if todo(1)~=0 fprintf('|SVM       | %1.6f | %1.6f |\n',m_acc_svm_s,m_auc_svm_s); end
    if todo(2)~=0 fprintf('|GSVM l1   | %1.6f | %1.6f |\n',m_acc_svm1_s,m_auc_svm1_s); end    
    if todo(3)~=0 fprintf('|GSVM l2   | %1.6f | %1.6f |\n',m_acc_gsvm2_s,m_auc_gsvm2_s); end     
    if todo(4)~=0 fprintf('|GSVM l-inf| %1.6f | %1.6f |\n',m_acc_gsvmi_s,m_auc_gsvmi_s); end     
    if todo(5)~=0 fprintf('|GSVM l-p  | %1.6f | %1.6f |\n',m_acc_gsvmp_s,m_auc_gsvmp_s); end  
    if todo(6)~=0 fprintf('|GSVM adapt| %1.6f | %1.6f |\n',m_acc_gsvma_s,m_auc_gsvma_s); end
    if todo(7)~=0 fprintf('|LDA       | %1.6f | %1.6f |\n',m_acc_lda_s,m_auc_lda_s); end
    if todo(8)~=0 fprintf('|LDA xDAWN | %1.6f | %1.6f |\n',m_acc_xlda_s,m_auc_xlda_s); end
    if todo(9)~=0 fprintf('|GSVM trace| %1.6f | %1.6f |\n',m_acc_gsvmt_s,m_auc_gsvmt_s); end     
      
    %% remtime and save
    if opt.remtime
%     if opt.mremtime
%         multi_remtime(filename_s,opt.mremtime,i,['In loop ' num2str(i) ])
%     else
        remtime(filename_s,i/nbloop,['In loop ' num2str(i) ]);
%     end
        
    end

    save(resfilename,'-regexp','.*_s')

end

%% final stuff
fprintf('Final stats:\n')
fprintf('|Method    |Test ACC  | AUC      |\n')
fprintf('-------------------------------------\n')
if todo(1)~=0 fprintf('|SVM       | %1.6f | %1.6f |\n',m_acc_svm_s,m_auc_svm_s); end
if todo(2)~=0 fprintf('|GSVM l1   | %1.6f | %1.6f |\n',m_acc_svm1_s,m_auc_svm1_s); end
if todo(3)~=0 fprintf('|GSVM l2   | %1.6f | %1.6f |\n',m_acc_gsvm2_s,m_auc_gsvm2_s); end
if todo(4)~=0 fprintf('|GSVM l-inf| %1.6f | %1.6f |\n',m_acc_gsvmi_s,m_auc_gsvmi_s); end
if todo(5)~=0 fprintf('|GSVM l-p  | %1.6f | %1.6f |\n',m_acc_gsvmp_s,m_auc_gsvmp_s); end
if todo(6)~=0 fprintf('|GSVM adapt| %1.6f | %1.6f |\n',m_acc_gsvma_s,m_auc_gsvma_s); end   
if todo(7)~=0 fprintf('|LDA       | %1.6f | %1.6f |\n',m_acc_lda_s,m_auc_lda_s); end
if todo(8)~=0 fprintf('|LDA xDAWN | %1.6f | %1.6f |\n',m_acc_xlda_s,m_auc_xlda_s); end
      
if opt.remtime
    remtime(filename_s,1,'Finished');
end

diary off

end


function psel=get_group_sparsity(svm,opt)

groups=opt.options_glsvm.groups;

vals=unique(groups);

w=svm.w;

epsilon=1e-6;

for i=1:length(vals)
   sel(i)=norm(w( groups==vals(i)))>epsilon;
end

psel=mean(sel);


end

