function Calc_Comp_methods_MTL(opt)


if ~isfield(opt,'get_data'); error('data loading function missing get_data(opt,i)'); end
if ~isfield(opt,'get_filename'); error('filename function missing get_filename(opt)'); end

if ~isfield(opt,'nbloop'); opt.nbloop=1; end
if ~isfield(opt,'seed'); opt.seed=1; end
if ~isfield(opt,'remtime'); opt.remtime=0; end
if ~isfield(opt,'mremtime'); opt.mremtime=0; end


nbloop=opt.nbloop;


seed=opt.seed;
rand('seed',seed);
randn('seed',seed);

filename_s=opt.get_filename(opt)

if opt.remtime
%     if opt.mremtime
%         multi_remtime(filename_s,opt.mremtime,0,nbloop)
%     else
        remtime(filename_s,0,'Start');
%     end
end

nbtodomax=10;

todo=opt.todo;

if length(todo)<nbtodomax
       todo=[todo zeros(1,nbtodomax-length(todo))];
    
end

nbtasks=opt.nbtasks;


resfilename=['results/' filename_s '.mat'];
diafilename=['results/' filename_s  '.log'];

opt_s=opt;

diary(diafilename)
diary on

criterions=opt.criterions;

% validatino vectors
Cvec=opt.Cvec;
Cvec2=opt.Cvec2;
qvec=opt.qvec;

norm_mtl=1;

switch opt.method
    
    


    case 4 % initialisation obligatoire
        svm_s=cell(opt.nbloop,opt.nbtasks);
        options_svm_s=cell(opt.nbloop,opt.nbtasks);
        LOG_s=cell(opt.nbloop,opt.nbtasks);
        
    case 6
        norm_mtl=0;
    case 7
        norm_mtl=0;

end


for i=1:opt.nbloop
    
    
    seed=i;
    rand('seed',seed);
    randn('seed',seed);


    %% initialisation
    disp(['Loop: ' num2str(i)])

    [X,Y,Xte,Yte,info]=opt.get_data(opt,i);
    
    [X,Xte,meanxapp_s,stdxapp_s] = normalizemeanstd_mtl(X,Xte);
    
    for j=1:nbtasks
        [indice{j}]=GetDataAppTestIdx(X{j},Y{j},round(opt.nbtrain*opt.ratiocv),opt.nbcv);
    end
    
    optval=[];
    
    optval.indice=indice;
    optval.nbloop=opt.nbcv;
    optval.criterions=criterions;
    optval.keeplog=1;
    
    switch opt.method
        
    
        case 1 
        %% svm standard indep
        disp('Indep SVM')

        optv=optval;

        % validation options
        optv.params{1}='C';
        optv.values{1}=Cvec;
        
        optv.learning=@svmclass2;
        optv.valmodels=@svmval2;
        
        optv.indice=indice{j};
        opts.use_idx=1;
        
        
        for j=1:nbtasks
            
            optv.use_idx=1;
            [svm_s{i,j},options_svm_s{i,j},LOG_s{i,j}]=cross_validation_loop(X{j},Y{j},opt.options_svm,optv);

            Ypred=svmval2(Xte{j},svm_s{i,j});
            prec_svm_s(i,j)=get_precision(Yte{j} , Ypred);

            acc_svm_s(i,j)=prec_svm_s(i,j).prec;
            auc_svm_s(i,j)=prec_svm_s(i,j).auc;
            sel_svm_s(i,j)=get_group_sparsity(svm_s{i,j},opt);
            time_svm_s(i,j)=LOG_s{i,j}.time;
        end

        m_acc_svm_s=mean(acc_svm_s,1)
        m_auc_svm_s=mean(auc_svm_s,1) 
        m_sel_svm_s=mean(sel_svm_s,1)
        
        
        fprintf('Loop stat:\n')
        fprintf('| Accuracy | AUC      | Selected |\n')
        fprintf('| %1.6f | %1.6f | %1.6f |\n',mean(m_acc_svm_s),mean(m_auc_svm_s),mean(m_sel_svm_s))

   
   
        case 2
        %% Indep GSVM2
        disp('Indep GSVM2')

        optv=optval;

        % validation options
        optv.params{1}='C';
        optv.values{1}=Cvec2;
        
        optv.learning=@glgroupsvmclass;
        optv.valmodels=@svmval2;
        optv.indice=indice{j};
        opts.use_idx=1;        
        
        options_glsvm=opt.options_glsvm;
        options_glsvm.norm=2;
        
        for j=1:nbtasks
            
            optv.use_idx=1;
            [svm_s{i,j},options_svm_s{i,j},LOG_s{i,j}]=cross_validation_loop(X{j},Y{j},options_glsvm,optv);

            Ypred=svmval2(Xte{j},svm_s{i,j});
            prec_svm_s(i,j)=get_precision(Yte{j} , Ypred);

            acc_svm_s(i,j)=prec_svm_s(i,j).prec;
            auc_svm_s(i,j)=prec_svm_s(i,j).auc;
            sel_svm_s(i,j)=get_group_sparsity(svm_s{i,j},opt);
            time_svm_s(i,j)=LOG_s{i,j}.time;
        end

        m_acc_svm_s=mean(acc_svm_s,1)
        m_auc_svm_s=mean(auc_svm_s,1) 
        m_sel_svm_s=mean(sel_svm_s,1)
        
        fprintf('Loop stat:\n')
        fprintf('| Accuracy | AUC      | Selected |\n')
        fprintf('| %1.6f | %1.6f | %1.6f |\n',mean(m_acc_svm_s),mean(m_auc_svm_s),mean(m_sel_svm_s))
        
        
        
        case 3
        %% Indep GSVMA
        disp('Indep GSVMA')

        optv=optval;

        % validation options
        optv.params{1}='C';
        optv.values{1}=Cvec2;
        
        optv.learning=@algroupsvmclass;
        optv.valmodels=@svmval2;
        optv.indice=indice{j};
        opts.use_idx=1;     
        
        options_glsvm=opt.options_alsvm;
        options_glsvm.norm=2;    
        options_glsvm.nbitermax2=0; 
        
        for j=1:nbtasks
            
            optv.use_idx=1;
            [svm_s{i,j},options_svm_s{i,j},LOG_s{i,j}]=cross_validation_loop(X{j},Y{j},options_glsvm,optv);

            Ypred=svmval2(Xte{j},svm_s{i,j});
            prec_svm_s(i,j)=get_precision(Yte{j} , Ypred);

            acc_svm_s(i,j)=prec_svm_s(i,j).prec;
            auc_svm_s(i,j)=prec_svm_s(i,j).auc;
            sel_svm_s(i,j)=get_group_sparsity(svm_s{i,j},opt);
            time_svm_s(i,j)=LOG_s{i,j}.time;
        end

        m_acc_svm_s=mean(acc_svm_s,1)
        m_auc_svm_s=mean(auc_svm_s,1) 
        m_sel_svm_s=mean(sel_svm_s,1)
        
        fprintf('Loop stat:\n')
        fprintf('| Accuracy | AUC      | Selected |\n')
        fprintf('| %1.6f | %1.6f | %1.6f |\n',mean(m_acc_svm_s),mean(m_auc_svm_s),mean(m_sel_svm_s))
        
        case 4
        %% MTL GSVM2
        disp('MTL GSVM2')

        optv=optval;

        % validation options
        optv.params{1}='C';
        optv.values{1}=Cvec2;
        
        optv.learning=@mtlgroupsvmclass;
        optv.valmodels=@mtlval;
        optv.indice=indice;
        optv.use_idx=0;     
        optv.get_data=@get_data_idx_mtl;
        
        options_glsvm=opt.options_mtl;
        options_glsvm.norm=2;

        [t_svm_s,t_options_svm_s,t_LOG_s]=cross_validation_loop(X,Y,options_glsvm,optv);
        
        svm_s{i}=t_svm_s;
        options_svm_s{i,1}=t_options_svm_s;
        LOG_s{i}=t_LOG_s;


        Ypred=mtlval(Xte,t_svm_s);
        prec_svm_s(i)=get_precision(Yte , Ypred);

        acc_svm_s(i,:)=prec_svm_s(i).precs;
        auc_svm_s(i,:)=prec_svm_s(i).aucs;
        for j=1:nbtasks
            sel_svm_s(i,j)=get_group_sparsity(t_svm_s{j},opt);
        end
        time_svm_s(i)=t_LOG_s.time;
        
        m_acc_svm_s=mean(acc_svm_s,1)
        m_auc_svm_s=mean(auc_svm_s,1) 
        m_sel_svm_s=mean(sel_svm_s,1)
        
        fprintf('Loop stat:\n')
        fprintf('| Accuracy | AUC      | Selected |\n')
        fprintf('| %1.6f | %1.6f | %1.6f |\n',mean(m_acc_svm_s),mean(m_auc_svm_s),mean(m_sel_svm_s))        
        
        case 5
        %% MTL GSVM2 with similarity
        disp('MTL GSVM2 sim')

        optv=optval;

        % validation options
        optv.params{1}='C';
        optv.values{1}=opt.Cvec3;

        optv.params{2}='reg_sim';
        optv.values{2}=opt.regvec;
        
        optv.learning=@mtlgroupsvmclass;
        optv.valmodels=@mtlval;
        optv.indice=indice;
        optv.use_idx=0;     
        optv.get_data=@get_data_idx_mtl;
        
        options_glsvm=opt.options_mtl;
        options_glsvm.norm=2;

        [t_svm_s,t_options_svm_s,t_LOG_s]=cross_validation_loop(X,Y,options_glsvm,optv);
        
        svm_s{i}=t_svm_s;
        options_svm_s{i,1}=t_options_svm_s;
        LOG_s{i}=t_LOG_s;


        Ypred=mtlval(Xte,t_svm_s);
        prec_svm_s(i)=get_precision(Yte , Ypred);

        acc_svm_s(i,:)=prec_svm_s(i).precs;
        auc_svm_s(i,:)=prec_svm_s(i).aucs;
        for j=1:nbtasks
            sel_svm_s(i,j)=get_group_sparsity(t_svm_s{j},opt);
        end
        time_svm_s(i)=t_LOG_s.time;
        
        m_acc_svm_s=mean(acc_svm_s,1)
        m_auc_svm_s=mean(auc_svm_s,1) 
        m_sel_svm_s=mean(sel_svm_s,1)
        
        fprintf('Loop stat:\n')
        fprintf('| Accuracy | AUC      | Selected |\n')
        fprintf('| %1.6f | %1.6f | %1.6f |\n',mean(m_acc_svm_s),mean(m_auc_svm_s),mean(m_sel_svm_s))     
        
        
        case 6
        %% SVM full
        disp('SVM full')

        
        [Xfull,Yfull]=get_full_data(X,Y);
        
        [Xfull,temp,meanxapp_s,stdxapp_s] = normalizemeanstd(Xfull);
        %[Xtefull,Ytefull,tasks]=get_full_data(Xte,Y);
        
        

        %[Xfull,Xtefull,meanxappfull,stdxappfull] = normalizemeanstd(Xfull,Xtefull);
        indice2=get_full_idx(indice);
     
        optv=optval;

        % validation options
        optv.params{1}='C';
        optv.values{1}=Cvec;
        
        optv.learning=@svmclass2;
        optv.valmodels=@svmval2;
        
        optv.indice=indice2;
        optv.use_idx=1;

        % validation
        [t_svm_s,t_options_svm_s,t_LOG_s]=cross_validation_loop(Xfull,Yfull,opt.options_svm,optv);
        
        svm_s{i}=t_svm_s;
        options_svm_s{i,1}=t_options_svm_s;
        LOG_s{i}=t_LOG_s;
        
             
        
        for j=1:nbtasks
            

            Ypred=svmval2(normalizemeanstd(Xte{j},[],meanxapp_s,stdxapp_s),svm_s{i});
            prec_svm_s(i,j)=get_precision(Yte{j} , Ypred);

            acc_svm_s(i,j)=prec_svm_s(i,j).prec;
            auc_svm_s(i,j)=prec_svm_s(i,j).auc;
            sel_svm_s(i,j)=get_group_sparsity(svm_s{i},opt);
            time_svm_s(i,j)=LOG_s{i}.time;
        end

        m_acc_svm_s=mean(acc_svm_s,1)
        m_auc_svm_s=mean(auc_svm_s,1) 
        m_sel_svm_s=mean(sel_svm_s,1)
        
        
        fprintf('Loop stat:\n')
        fprintf('| Accuracy | AUC      | Selected |\n')
        fprintf('| %1.6f | %1.6f | %1.6f |\n',mean(m_acc_svm_s),mean(m_auc_svm_s),mean(m_sel_svm_s))

      case 7
        %% GSVM2 full
        disp('GSVM2 full')

        
        [Xfull,Yfull]=get_full_data(X,Y);
        %[Xtefull,Ytefull,tasks]=get_full_data(Xte,Y);
        
        

        %[Xfull,Xtefull,meanxappfull,stdxappfull] = normalizemeanstd(Xfull,Xtefull);
        indice2=get_full_idx(indice);
     
        optv=optval;

        % validation options
        optv.params{1}='C';
        optv.values{1}=Cvec2;
        
        optv.learning=@glgroupsvmclass;
        optv.valmodels=@svmval2;
        optv.indice=indice2;
        opts.use_idx=1;        
        
        options_glsvm=opt.options_glsvm;
        options_glsvm.norm=2;

        % validation
        [t_svm_s,t_options_svm_s,t_LOG_s]=cross_validation_loop(Xfull,Yfull,options_glsvm,optv);
        
        svm_s{i}=t_svm_s;
        options_svm_s{i,1}=t_options_svm_s;
        LOG_s{i}=t_LOG_s;
        
             
        
        for j=1:nbtasks
            
            Ypred=svmval2(Xte{j},svm_s{i});
            prec_svm_s(i,j)=get_precision(Yte{j} , Ypred);

            acc_svm_s(i,j)=prec_svm_s(i,j).prec;
            auc_svm_s(i,j)=prec_svm_s(i,j).auc;
            sel_svm_s(i,j)=get_group_sparsity(svm_s{i},opt);
            time_svm_s(i,j)=LOG_s{i}.time;
            
        end

        m_acc_svm_s=mean(acc_svm_s,1)
        m_auc_svm_s=mean(auc_svm_s,1) 
        m_sel_svm_s=mean(sel_svm_s,1)
        
        
        fprintf('Loop stat:\n')
        fprintf('| Accuracy | AUC      | Selected |\n')
        fprintf('| %1.6f | %1.6f | %1.6f |\n',mean(m_acc_svm_s),mean(m_auc_svm_s),mean(m_sel_svm_s))
  
        
        otherwise
            error('not a known method')
    end    
    
    %% remtime and save
    if opt.remtime
%     if opt.mremtime
%         multi_remtime(filename_s,opt.mremtime,i,['In loop ' num2str(i) ])
%     else
        remtime(filename_s,i/nbloop,['In loop ' num2str(i) ]);
%     end
        
    end

    save(resfilename,'-regexp','.*_s')

end

%% final stuff

    
if opt.remtime
    remtime(filename_s,1,'Finished');
end

diary off

end


function psel=get_group_sparsity(svm,opt)

groups=opt.options_glsvm.groups;

vals=unique(groups);

w=svm.w;

epsilon=1e-6;

for i=1:length(vals)
   sel(i)=norm(w( groups==vals(i)))>epsilon;
end

psel=mean(sel);


end

function [X2,Y2,X2val,Y2val]=get_data_idx_mtl(X,Y,niter,opts)

for i=1:length(Y)

indice=opts.indice{i}(niter);

X2{i}=X{i}(indice.app,:);
Y2{i}=Y{i}(indice.app,:);

X2val{i}=X{i}(indice.test,:);
Y2val{i}=Y{i}(indice.test,:);

end

end

