function Calc_Comp_methods_sparsity(opt)


if ~isfield(opt,'get_data'); error('data loading function missing get_data(opt,i)'); end
if ~isfield(opt,'get_filename'); error('filename function missing get_filename(opt)'); end

if ~isfield(opt,'nbloop'); opt.nbloop=1; end
if ~isfield(opt,'seed'); opt.seed=1; end
if ~isfield(opt,'remtime'); opt.remtime=0; end
if ~isfield(opt,'mremtime'); opt.mremtime=0; end


nbloop=opt.nbloop;


seed=opt.seed;
rand('seed',seed);
randn('seed',seed);

filename_s=opt.get_filename(opt);

if opt.remtime
%     if opt.mremtime
%         multi_remtime(filename_s,opt.mremtime,0,nbloop)
%     else
        remtime(filename_s,0,'Start');
%     end
end

nbtodomax=10;

todo=opt.todo;

if length(todo)<nbtodomax
       todo=[todo zeros(1,nbtodomax-length(todo))];
    
end


resfilename=['results/' filename_s '.mat'];
diafilename=['results/' filename_s  '.log'];

opt_s=opt;

diary(diafilename)
diary on

criterions=opt.criterions;

% validatino vectors
Cvec=opt.Cvec;
Cvec2=opt.Cvec2;
qvec=opt.qvec;

for i=1:nbloop
    %% initialisation
    disp(['Loop: ' num2str(i)])

    [X,Y,Xte,Yte,info]=opt.get_data(opt,i);
    
    [X,Xte,meanxapp_s,stdxapp_s] = normalizemeanstd(X,Xte);
    
    
    [indice]=GetDataAppTestIdx(X,Y,round(opt.nbtrain*opt.ratiocv),opt.nbcv);
    
    optval=[];
    
    optval.indice=indice;
    optval.nbloop=opt.nbcv;
    optval.criterions=criterions;
    optval.use_idx=1;
    optval.keeplog=1;
    
    
    %% svm standard
    if todo(1)==1
        disp('Standard SVM')

        optv=optval;

        % validation options
        optv.params{1}='C';
        optv.values{1}=Cvec;
        
        optv.learning=@svmclass2;
        optv.valmodels=@svmval2;
        
        [svm_s{i},options_svm_s{i},LOG_s{i}]=cross_validation_loop(X,Y,opt.options_svm,optv);
        
        Ypred=svmval2(Xte,svm_s{i});
        prec_svm_s(i)=get_precision(Yte , Ypred);
        
        acc_svm_s(i)=prec_svm_s(i).prec;
        auc_svm_s(i)=prec_svm_s(i).auc;
        sel_svm_s(i)=get_group_sparsity(svm_s{i},opt);
        time_svm_s(i)=LOG_s{i}.time;

        m_acc_svm_s=mean(acc_svm_s);
        m_auc_svm_s=mean(auc_svm_s);  
        
        fprintf('| Acc      | Auc       |\n')
        fprintf('| %1.6f | %1.6f |\n',acc_svm_s(i),auc_svm_s(i))

    end
    
    
    
    for j=1:length(Cvec2)

        opt.options_glsvm.C=  Cvec2(j);
        
        %% svn l1
        if todo(2)==1

            options_glsvm=opt.options_glsvm;
            options_glsvm.norm=1;
            
            if j>1
                options_glsvm.W0=[svm1_s{i,j-1}.w;svm1_s{i,j-1}.w0];
            end
            
            tic 
            [svm1_s{i,j},dummy,LOG1_s{i,j}]= glgroupsvmclass(X,Y,options_glsvm);
            time_svm1_s(i,j)=toc;
               
            Ypred=svmval2(Xte,svm1_s{i,j});
            prec_svm1_s(i,j)=get_precision(Yte , Ypred);

            acc_svm1_s(i,j)=prec_svm1_s(i,j).prec;
            auc_svm1_s(i,j)=prec_svm1_s(i,j).auc;
            sel_svm1_s(i,j)=get_group_sparsity(svm1_s{i,j},opt);
            %time_svm1_s(i,j)=LOG1_s{i,j}.time;

            m_acc_svm1_s=mean(acc_svm1_s,1);
            m_auc_svm1_s=mean(auc_svm1_s,1);
            m_sel_svm1_s=mean(sel_svm1_s,1);
           % m_auc_svm1_s=mean(auc_svm1_s);

        end
        
        %% svn l2
        if todo(3)==1

            options_glsvm=opt.options_glsvm;
            options_glsvm.norm=2;
            
            if j>1
                options_glsvm.W0=[gsvm2_s{i,j-1}.w;gsvm2_s{i,j-1}.w0];
            end
            
            tic 
            [gsvm2_s{i,j},dummy,LOG2_s{i,j}]= glgroupsvmclass(X,Y,options_glsvm);
            time_gsvm2_s(i,j)=toc;
               
            Ypred=svmval2(Xte,gsvm2_s{i,j});
            prec_gsvm2_s(i,j)=get_precision(Yte , Ypred);

            acc_gsvm2_s(i,j)=prec_gsvm2_s(i,j).prec;
            auc_gsvm2_s(i,j)=prec_gsvm2_s(i,j).auc;
            sel_gsvm2_s(i,j)=get_group_sparsity(gsvm2_s{i,j},opt);
            %time_svm1_s(i,j)=LOG1_s{i,j}.time;

            m_acc_gsvm2_s=mean(acc_gsvm2_s,1);
            m_auc_gsvm2_s=mean(auc_gsvm2_s,1);
            m_sel_gsvm2_s=mean(sel_gsvm2_s,1);
           % m_auc_svm1_s=mean(auc_svm1_s);

        end
        
        
        %% svn li
        if todo(4)==1

%             options_glsvm=opt.options_glsvm;
%             options_glsvm.norm=1.5;
%             
%             if j>1
%                 options_glsvm.W0=[gsvm2_s{i,j-1}.w;gsvm2_s{i,j-1}.w0];
%             end
%             
%             tic 
%             [gsvmp_s{i,j},dummy,LOGp_s{i,j}]= glgroupsvmclass(X,Y,options_glsvm);
%             time_gsvmp_s(i,j)=toc;
%                
%             Ypred=svmval2(Xte,gsvmp_s{i,j});
%             prec_gsvmp_s(i,j)=get_precision(Yte , Ypred);
% 
%             acc_gsvmp_s(i,j)=prec_gsvmp_s(i,j).prec;
%             auc_gsvmp_s(i,j)=prec_gsvmp_s(i,j).auc;
%             sel_gsvmp_s(i,j)=get_group_sparsity(gsvmp_s{i,j},opt);
%             %time_svm1_s(i,j)=LOG1_s{i,j}.time;
% 
%             m_acc_gsvmp_s=mean(acc_gsvmp_s,1);
%             m_auc_gsvmp_s=mean(auc_gsvmp_s,1);
%             m_sel_gsvmp_s=mean(sel_gsvmp_s,1);
           % m_auc_svm1_s=mean(auc_svm1_s);

        end

        %% svn lp
        if todo(5)==1

            options_glsvm=opt.options_glsvm;
            options_glsvm.norm=1.5;
            
            if j>1
                options_glsvm.W0=[gsvmp_s{i,j-1}.w;gsvmp_s{i,j-1}.w0];
            end
            
            tic 
            [gsvmp_s{i,j},dummy,LOGp_s{i,j}]= glgroupsvmclass(X,Y,options_glsvm);
            time_gsvmp_s(i,j)=toc;
               
            Ypred=svmval2(Xte,gsvmp_s{i,j});
            prec_gsvmp_s(i,j)=get_precision(Yte , Ypred);

            acc_gsvmp_s(i,j)=prec_gsvmp_s(i,j).prec;
            auc_gsvmp_s(i,j)=prec_gsvmp_s(i,j).auc;
            sel_gsvmp_s(i,j)=get_group_sparsity(gsvmp_s{i,j},opt);
            %time_svm1_s(i,j)=LOG1_s{i,j}.time;

            m_acc_gsvmp_s=mean(acc_gsvmp_s,1);
            m_auc_gsvmp_s=mean(auc_gsvmp_s,1);
            m_sel_gsvmp_s=mean(sel_gsvmp_s,1);
           % m_auc_svm1_s=mean(auc_svm1_s);

        end
        
        
        %% adaptive group lasso
        if todo(6)==1

            options_glsvm=opt.options_alsvm;
            options_glsvm.norm=2;
            options_glsvm.C=Cvec2(j);
            
            if j>1
                options_glsvm.W0=[gsvma_s{i,j-1}.w;gsvma_s{i,j-1}.w0];
            end
            
            tic 
            [gsvma_s{i,j},dummy,LOGa_s{i,j}]= algroupsvmclass(X,Y,options_glsvm);
            time_asvmp_s(i,j)=toc;
               
            Ypred=svmval2(Xte,gsvma_s{i,j});
            prec_gsvma_s(i,j)=get_precision(Yte , Ypred);

            acc_gsvma_s(i,j)=prec_gsvma_s(i,j).prec;
            auc_gsvma_s(i,j)=prec_gsvma_s(i,j).auc;
            sel_gsvma_s(i,j)=get_group_sparsity(gsvma_s{i,j},opt);
            %time_svm1_s(i,j)=LOG1_s{i,j}.time;

            m_acc_gsvma_s=mean(acc_gsvma_s,1);
            m_auc_gsvma_s=mean(auc_gsvma_s,1);
            m_sel_gsvma_s=mean(sel_gsvma_s,1);
           % m_auc_svm1_s=mean(auc_svm1_s);

        end        

    end
 
    
    %% remtime and save
    if opt.remtime
%     if opt.mremtime
%         multi_remtime(filename_s,opt.mremtime,i,['In loop ' num2str(i) ])
%     else
        remtime(filename_s,i/nbloop,['In loop ' num2str(i) ]);
%     end
        
    end

    save(resfilename,'-regexp','.*_s')

end

%% final stuff
fprintf('Final stats:\n')
fprintf('|Method    |Test ACC  | AUC      |\n')
fprintf('-------------------------------------\n')
if todo(1)~=0 fprintf('|SVM       | %1.6f | %1.6f |\n',m_acc_svm_s,m_auc_svm_s); end
if todo(2)~=0 fprintf('|GSVM l1   | %1.6f | %1.6f |\n',m_acc_svm1_s,m_auc_svm1_s); end
if todo(3)~=0 fprintf('|GSVM l2   | %1.6f | %1.6f |\n',m_acc_gsvm2_s,m_auc_gsvm2_s); end
%if todo(4)~=0 fprintf('|GSVM l-inf| %1.6f | %1.6f |\n',m_acc_gsvmi_s,m_auc_gsvmi_s); end
if todo(5)~=0 fprintf('|GSVM l-p  | %1.6f | %1.6f |\n',m_acc_gsvmp_s,m_auc_gsvmp_s); end
if todo(6)~=0 fprintf('|GSVM adapt| %1.6f | %1.6f |\n',m_acc_gsvma_s,m_auc_gsvma_s); end   
    
if opt.remtime
    remtime(filename_s,1,'Finished');
end

diary off

end


function psel=get_group_sparsity(svm,opt)

groups=opt.options_glsvm.groups;

vals=unique(groups);

w=svm.w;

epsilon=1e-6;

for i=1:length(vals)
   sel(i)=norm(w( groups==vals(i)))>epsilon;
end

psel=mean(sel);


end

