function Calc_Comp_methods_svm(opt)


if ~isfield(opt,'get_data'); error('data loading function missing get_data(opt,i)'); end
if ~isfield(opt,'get_filename'); error('filename function missing get_filename(opt)'); end

if ~isfield(opt,'nbloop'); opt.nbloop=1; end
if ~isfield(opt,'seed'); opt.seed=1; end
if ~isfield(opt,'remtime'); opt.remtime=0; end
if ~isfield(opt,'mremtime'); opt.mremtime=0; end


nbloop=opt.nbloop;


seed=opt.seed;
rand('seed',seed);
randn('seed',seed);

methods={'svm','featsvm_l1','featsvm_wl1','fixed_ffsvm','ffsvm'};

filename_s=opt.get_filename(opt);

if opt.remtime
%     if opt.mremtime
%         multi_remtime(filename_s,opt.mremtime,0,nbloop)
%     else
        remtime(filename_s,0,'Start');
%     end
end

nbtodomax=10;

todo=opt.todo;

if length(todo)<nbtodomax
       todo=[todo zeros(1,nbtodomax-length(todo))];
    
end


resfilename=['' filename_s '.mat'];
diafilename=['' filename_s  '.log'];

opt_s=opt;

diary(diafilename)
diary on

nb=1;

criterions=opt.criterions;

% validatino vectors


disp(['Filename : ' filename_s])

%% loop

for i=1:nbloop
    %% initialisation
    disp(['Loop: ' num2str(i)])

    [X,Y,Xte,Yte,info]=opt.get_data(opt,i);
    
    [X,Xte,meanxapp_s,stdxapp_s] = normalizemeanstd(X,Xte);
    
    
    [indice]=GetDataAppTestIdx(X,Y,round(opt.nbapp*opt.ratiocv),opt.nbcv);
    
    optval=[];
    
    optval.indice=indice;
    optval.nbloop=opt.nbcv;
    optval.criterions=criterions;
    optval.use_idx=1;
    optval.keeplog=1;
    
    nb=1;
    
    
    %% svm standard
    if todo(nb)==1
        
        method= methods{nb};
        disp(['Méthode: ' method])
        
        optv=optval;

        % validation options
        optv.params{1}='C';
        optv.values{1}=opt.Csvmval;

        optv.params{2}='kerneloption';
        optv.values{2}=opt.koptval;        
        
        optv.learning=@svmclass2;
        optv.valmodels=@svmval2;
        
        options=opt.options_svm;
              
        eval(['[' method '_s{i},options_' method '_s{i},LOG_' method '_s{i}]=cross_validation_loop(X,Y,options,optv);'])
        eval(['Ypred=optv.valmodels(Xte,' method '_s{i});'])
        
        eval(['prec_' method '_s{i}= get_precision(Yte , Ypred);'])
        eval(['acc_' method '_s(i)=prec_' method '_s{i}.prec;']);
        eval(['auc_' method '_s(i)=prec_' method '_s{i}.auc;'])
        eval(['mse_' method '_s(i)=prec_' method '_s{i}.mse;'])
        
        eval(['m_acc_' method '_s=mean(acc_' method '_s);'])
        eval(['m_auc_' method '_s=mean(auc_' method '_s);'])
        eval(['m_mse_' method '_s=mean(mse_' method '_s);'])  
        
        fprintf('| Acc      | Auc      | Mse      |\n')
        eval(['fprintf(''| %1.6f | %1.6f | %1.6f |\n'',acc_' method '_s(i),auc_' method '_s(i),mse_' method '_s(i))'])
        
    end
    nb=nb+1;
    
    
    %% svm feat fourier
    if todo(nb)==1
        
        method= methods{nb};
        disp(['Méthode: ' method])
        
        optv=optval;

        % validation options
        optv.params{1}='C';
        optv.values{1}=opt.Cfeatval;
   
        
        optv.learning=@featsvm;
        optv.valmodels=@inflinearsvmval;
        
        options=opt.options_featsvm;
        
        eval(['[' method '_s{i},options_' method '_s{i},LOG_' method '_s{i}]=cross_validation_loop(X,Y,options,optv);'])
        eval(['Ypred=optv.valmodels(Xte,' method '_s{i});'])
        
        eval(['prec_' method '_s{i}= get_precision(Yte , Ypred);'])
        eval(['acc_' method '_s(i)=prec_' method '_s{i}.prec;']);
        eval(['auc_' method '_s(i)=prec_' method '_s{i}.auc;'])
        eval(['mse_' method '_s(i)=prec_' method '_s{i}.mse;'])
        
        eval(['m_acc_' method '_s=mean(acc_' method '_s);'])
        eval(['m_auc_' method '_s=mean(auc_' method '_s);'])
        eval(['m_mse_' method '_s=mean(mse_' method '_s);'])  
        
        fprintf('| Acc      | Auc      | Mse      |\n')
        eval(['fprintf(''| %1.6f | %1.6f | %1.6f |\n'',acc_' method '_s(i),auc_' method '_s(i),mse_' method '_s(i))'])
        
    end    
    nb=nb+1;
    
    %% svm feat weighted fourier
    if todo(nb)==1
        
        method= methods{nb};
        disp(['Méthode: ' method])
        
        optv=optval;

        % validation options
        optv.params{1}='C';
        optv.values{1}=opt.Cfeatval;
   
        
        optv.learning=@featsvm;
        optv.valmodels=@inflinearsvmval;
        
        options=opt.options_featsvm;
        
        options.features='wfourier';
        
        eval(['[' method '_s{i},options_' method '_s{i},LOG_' method '_s{i}]=cross_validation_loop(X,Y,options,optv);'])
        eval(['Ypred=optv.valmodels(Xte,' method '_s{i});'])
        
        eval(['prec_' method '_s{i}= get_precision(Yte , Ypred);'])
        eval(['acc_' method '_s(i)=prec_' method '_s{i}.prec;']);
        eval(['auc_' method '_s(i)=prec_' method '_s{i}.auc;'])
        eval(['mse_' method '_s(i)=prec_' method '_s{i}.mse;'])
        
        eval(['m_acc_' method '_s=mean(acc_' method '_s);'])
        eval(['m_auc_' method '_s=mean(auc_' method '_s);'])
        eval(['m_mse_' method '_s=mean(mse_' method '_s);'])  
        
        fprintf('| Acc      | Auc      | Mse      |\n')
        eval(['fprintf(''| %1.6f | %1.6f | %1.6f |\n'',acc_' method '_s(i),auc_' method '_s(i),mse_' method '_s(i))'])
        
    end    
    nb=nb+1;
    
    %% svm fourier features fixed feat
    
    if todo(nb)==1
        
        method= methods{nb};
        disp(['Méthode: ' method])
        
        optv=optval;

        % validation options
        optv.params{1}='C';
        optv.values{1}=opt.Cfeatval;
   
        
        optv.learning=@featsvm2;
        optv.valmodels=@inflinearsvmval;
        
        options=opt.options_ffsvm;
        
        options.features='fourier';
        
        eval(['[' method '_s{i},options_' method '_s{i},LOG_' method '_s{i}]=cross_validation_loop(X,Y,options,optv);'])
        eval(['Ypred=optv.valmodels(Xte,' method '_s{i});'])
        
        eval(['prec_' method '_s{i}= get_precision(Yte , Ypred);'])
        eval(['acc_' method '_s(i)=prec_' method '_s{i}.prec;']);
        eval(['auc_' method '_s(i)=prec_' method '_s{i}.auc;'])
        eval(['mse_' method '_s(i)=prec_' method '_s{i}.mse;'])
        
        eval(['m_acc_' method '_s=mean(acc_' method '_s);'])
        eval(['m_auc_' method '_s=mean(auc_' method '_s);'])
        eval(['m_mse_' method '_s=mean(mse_' method '_s);'])  
        
        fprintf('| Acc      | Auc      | Mse      |\n')
        eval(['fprintf(''| %1.6f | %1.6f | %1.6f |\n'',acc_' method '_s(i),auc_' method '_s(i),mse_' method '_s(i))'])
        
    end    
    nb=nb+1;    
    

    %% svm fourier features feat
    
    if todo(nb)==1
        
        method= methods{nb};
        disp(['Méthode: ' method])
        
        optv=optval;

        % validation options
        optv.params{1}='lambdaw';
        optv.values{1}=opt.lambdawval;
   
        optv.params{1}='lambdaV';
        optv.values{1}=opt.lambdaVval;
        
        optv.learning=@ffsvm;
        optv.valmodels=@inflinearsvmval;
        
        options=opt.options_ffsvm;
        
        options.features='fourier';
        
        eval(['[' method '_s{i},options_' method '_s{i},LOG_' method '_s{i}]=cross_validation_loop(X,Y,options,optv);'])
        eval(['Ypred=optv.valmodels(Xte,' method '_s{i});'])
        
        eval(['prec_' method '_s{i}= get_precision(Yte , Ypred);'])
        eval(['acc_' method '_s(i)=prec_' method '_s{i}.prec;']);
        eval(['auc_' method '_s(i)=prec_' method '_s{i}.auc;'])
        eval(['mse_' method '_s(i)=prec_' method '_s{i}.mse;'])
        
        eval(['m_acc_' method '_s=mean(acc_' method '_s);'])
        eval(['m_auc_' method '_s=mean(auc_' method '_s);'])
        eval(['m_mse_' method '_s=mean(mse_' method '_s);'])  
        
        fprintf('| Acc      | Auc      | Mse      |\n')
        eval(['fprintf(''| %1.6f | %1.6f | %1.6f |\n'',acc_' method '_s(i),auc_' method '_s(i),mse_' method '_s(i))'])
        
    end    
    nb=nb+1;    
    
    fprintf('Loop stats:\n')
    fprintf('|Method              | Test ACC | AUC      | MSE      |\n')
    fprintf('-------------------------------------------------------\n')
    for k=1:nbtodomax
       if todo(k)
           method=methods{k} ;
           eval(['fprintf(''|%20s| %1.6f | %1.6f | %1.6f |\n'',''' method ''',m_acc_' method '_s,m_auc_' method '_s, m_mse_' method '_s);'])
       end
    end

    %% remtime and save
    if opt.remtime
%     if opt.mremtime
%         multi_remtime(filename_s,opt.mremtime,i,['In loop ' num2str(i) ])
%     else
        remtime(filename_s,i/nbloop,['In loop ' num2str(i) ]);
%     end
        
    end

    save(resfilename,'-regexp','.*_s')

end

 
if opt.remtime
    remtime(filename_s,1,'Finished');
end

diary off

end


function psel=get_group_sparsity(svm,opt)

groups=opt.options_glsvm.groups;

vals=unique(groups);

w=svm.w;

epsilon=1e-6;

for i=1:length(vals)
   sel(i)=norm(w( groups==vals(i)))>epsilon;
end

psel=mean(sel);


end

