function  [W,F]=L2prox(X,signal,lambda,options)

%
% min_{W}  1/2 || S- XW||_F^2 + \lambda \Omega(W)


if isfield(options,'init');
    W=options.init;
else

            K=size(signal,2);
            TailleDic=size(X,2);
            W=zeros(TailleDic,K);
            %pas=1/norm(X'*X);

end;


V=W;
Wold=W+1;

az=1;


        XtX=X'*X;
        XtS=X'*signal;
        pas=1/norm(XtX);
        Fold=0.5*norm(signal-X*W,'fro').^2;
   

eta=0.1;
j=0;

F=[];
while j <= 2 || (abs(F(j-1)-F(j))/abs(F(j-1)))>options.threshold
%while norm(W-Wold)>options.threshold
%max(max(abs(XtS-XtX*W)))
%abs(Fold-F)
    %norm(W-Wold)
    %max(max(abs(W-Wold)))
    switch options.regularizer
        case '\ell_1-\ell_2'
            normeW=sqrt(sum(W.^2,2));
        case '\ell_1-\ell_1'
            normeW=sum(sum(abs(W)));
        case 'frobenius2'
            normeW=norm(W,'fro').^2;
        case 'none'
            normeW=0;
    end;
    %----------------------------------------------------------------------
    % objective value
    %----------------------------------------------------------------------

    fobj=0.5*norm(signal-X*W,'fro').^2;
     
    sumnorm = sum(lambda.*normeW);
    F(j+1)=fobj+sumnorm;

    %----------------------------------------------------------------------
    % gradient and backtracking step
    %----------------------------------------------------------------------


            grad=-XtS+XtX*V;
  
%
%   beware of backtracking computing the trace may be expensive
%     lin=trace((W-V)'*grad);
%     while F > fobj+sumnorm+lin + 1/2/pas*norm(W-V,'fro').^2;
%         pas=pas*eta;
%     end;
    Wold=W;
    %----------------------------------------------------------------------
    % gradient step
    %----------------------------------------------------------------------
    W=V-pas*grad;   % gradient step
    %----------------------------------------------------------------------
    % proximal step
    %----------------------------------------------------------------------
    switch options.regularizer
        case '\ell_1-\ell_2'
            K=size(W,2);
            normeW=sqrt(sum(W.^2,2));      % shrink
            bool=normeW>(lambda*pas);
            aux=(1-lambda*pas./normeW).*bool;
            W=W.*(aux*ones(1,K));           % shrink
        case '\ell_1-\ell_1'
            W=sign(W).*(abs(W)-lambda*pas).*((abs(W)-lambda*pas)>0);
        case 'frobenius2'
            W=W/(1+2*lambda);
        case 'none'
    end;

    a1=2/( (j-1)+3);
    delta=W-Wold;
    V=W+(1-az)/az*a1*delta;
    az=a1;
   % V=W;
    j=j+1;

end;

