%
%  Script of an example of sparse multi-task learning 
%  on a toy dataset
%

clear all
close all
addpath('..')


r=[4];
N=100;
nbapp=100;
nbval=50;
nbtest=500;
sigmas=1;
nbtasks=4;
C=10;

rand('seed',0);
randn('seed',0);

verbose=1;

%------------------------------------------------------
% choosing the stopping criterion
%------------------------------------------------------
options.stopvariation=1; 
options.seuildiffsigma=1e-4;    
%--------------------------------------------------------------------------
% p norm parameter
%--------------------------------------------------------------------------
options.stopvariationlp=1; % use variation of weights for stopping criterion
options.seuildiffsigmalp=1e-2;
options.lpnbitermax = 100;
options.norm_p  = 1;
options.epsilon=0.001;

%------------------------------------------------------
% Setting some numerical parameters
%------------------------------------------------------

options.lambdareg = 1e-8;          % ridge added to kernel matrix
options.linear=0;
options.multiclass=0;
%------------------------------------------------------
% some algorithms paramaters
%------------------------------------------------------%
options.nbitermax=100;             % maximal number of iteration              
options.verbosesvm=0;              % verbosity of inner svm algorithm




%------------------------------------------------------------------------
%                  Building Kernel and normalizing
%------------------------------------------------------------------------

kernelt={'poly'  };
kerneloptionvect={ [1] };
variablevec={'single'};
dim=N;
[kernel,kerneloptionvec,variableveccell]=CreateKernelListWithVariable(variablevec,dim,kernelt,kerneloptionvect);
[InfoKernel]=CreateInfoKernel(variablevec,dim,kernel,kerneloptionvec);

[X,Y,Xte,Yte,Xval,Yval]=GetMultiTaskFeatures(nbtasks,r,N,nbapp,nbtest,sigmas,nbval);
for k=1:nbtasks
    [X{k},Xval{k},meanxapp{k},stdxapp{k}] = normalizemeanstd(X{k},Xval{k});
    [aux,Xte{k}] = normalizemeanstd(X{k},Xte{k},meanxapp{k},stdxapp{k});
end;
K=mtlkernels(X,InfoKernel,options);
[K,Weigths]=mtlNormalizekernels(K);


%-------------------------------------------------------------------------
%                  EM L1-Lq
%--------------------------------------------------------------------------
options.norm_q=0; % this is s in the paper
[d,w,bsvm,posw,Norme,storyEM]=mtlmklsvmEM(K,Y,C,options,verbose);
ErrL1L2=EvalMultiTaskEM(X,Xte,Yte,InfoKernel,Weigths,d,w,bsvm,posw,options)
sparseL1L2=sum(sum(d)>0.01)
%-------------------------------------------------------------------------
%                  EM Lp-Lq
%--------------------------------------------------------------------------
%  options.norm_q=0;  
% options.norm_p=0.5;
%  options.annealing=0;
% % options.epsilon=1e-3;
% tic
% [d2,w,bsvm,posw,NormeFtaskKernel,betasEM] = lpmklmtlsvmEM(K,Y,C,options,verbose);
% toc
% ErrLpL2=EvalMultiTaskEM(X,Xte,Yte,InfoKernel,Weigths,d2./(betasEM.^2),w,bsvm,posw,options)
% % sparseLpL2=sum(sum(d2)>0.01)


%--------------------------------------------------------------------------
%       Proximal algorithm for sparse Lp-Lp MTL
%--------------------------------------------------------------------------

lambda=10;
options.threshold=0.001;
options.norm_q=2; % here we have the real q
W=mtlmklsvmProx(X,Y,lambda,options,verbose); % proximal 
Err=EvalMultiTaskProx(Xte,Yte,W);
[Wp,weigth] = lpmklmtlsvmProx(X,Y,lambda,options,verbose); % lp prox
Wa=mtlmklsvmProxAdapt(X,Y,lambda,options,verbose); %




