function [W,b,obj]=groupsvmProx(X,Y,lambda,options,verbose)


% Usage
%
% [W,b,obj]=mtlmklsvmProx(X,Y,lambda,options,verbose);

%  X : cells of input vector. 1 cell per task
%  Y : cells of outputs 1 cell per task
%  lambda : regularization parameters
%  options.norm_q :    should be equal to 2 for l1-ell2
%  options.seuildiffsigma : stopping criterion on variation of objective
%                               value
%  options.nbitermax : maximal number of iteration
%
%   note that we have implemented a version which X{k} are supposed to have the same dimension
%
%
%  outputs
%
%
%   W  : matrix of weights for linear decision functions
%   b  : bias
%   obj : objective value
%
%
%

% A. Rakotomamonjy 13/08/2010

groups=options.groups;

vals=unique(groups);
W=zeros(size(X,2),1);
dim=size(X,2);

V=W;
Wold=W+1;
az=1;
%pas=0.001;
pas=1/norm(X'*X);
eta=0.5;
j=0;
T=3;

b=0;

 Xt=X.*repmat(Y,1,dim);

while (j< T+1 | (max(obj(j-T:j))-min(obj(j-T:j)))/max(obj(j-T:j))> options.seuildiffsigma)& j < options.nbitermax;    % shrink


    sumnorm = Omega12_group(W,options.groups);
    grad=zeros(dim,1);
    b=findBiasProx2(X,Y,W);


        Loss=1-Y.*(X*W+b);
        Loss=Loss.^2.*(Loss>0);

        grad=-Xt'*Loss;
   
    fobj=sum(sum(Loss));

    %
    % logistic regression
    %

    %     for k=1:nbtasks
    %         Loss(:,k)=log(1 + exp(-Y{k}.*(X{k}*W(:,k))));
    %         for i=1:size(Loss,1);
    %             grad(:,k)=grad(:,k)- (X{k}(i,:)*Y{k}(i)*exp(-Y{k}(i).*(X{k}(i,:)*W(:,k))))' /(1 + exp(-Y{k}(i).*(X{k}(i,:)*W(:,k))));
    %
    %         end;
    %     end;
    %     fobj=sum(sum(Loss));


    F=fobj+sumnorm;
    obj(j+1)=F;
    lin=sum((W-V).*(grad));
 %   while F > fobj+sumnorm+lin + 1/2/pas*norm(W-V,'fro').^2;
  %      pas=pas*eta;
  %  end;
    Wold=W;
    W=V-pas*grad;   % gradient
    

            normeW=groupnorm(W,groups);      % shrink
            bool=normeW>(lambda*pas);
            normeW(~bool)=eps;
            aux=(1-lambda*pas./normeW).*bool;
            for i=1:length(vals)
            W(groups==vals(i))=W(groups==vals(i))*aux(i);           % shrink
            end

    
    



    a1=2/( (j-1)+3);
    delta=W-Wold;
    V=W+(1-az)/az*a1*delta;
    az=a1;
    j=j+1;
    max(max(abs(W-Wold)));
end;

end


function res=groupnorm(W,groups)
    
    vals=unique(groups);
    
    for i=1:length(vals)
       
        res(i)=norm(W(groups==vals(i)));
        
    end
    

end
