% Demo for the use of linear svm with mixed norm regularisaton
%
%


clear all
close all


addpath(genpath('.'))

%%
%
%   Creating Data
%

seed=1985 % best year ever
rand('state',seed);
randn('state',seed);

nbapp=1000;
nn=20;
nbtest=nn*nn;
sigma=0.2;
[xapp,yapp,xtest,ytest,xtest1,xtest2]=datasets('gaussian',nbapp,nbtest,sigma);
%------- Building a 2D Grid for function evaluation -------------------------
[xtest1 xtest2]  = meshgrid([-1:.05:1]*3.5,[-1:0.05:1]*3); 
nn = length(xtest1); 
xtest = [reshape(xtest1 ,nn*nn,1) reshape(xtest2 ,nn*nn,1)]; 

% randomly permutes examples
idxs=randperm(length(yapp));
yapp=yapp(idxs);
xapp=xapp(idxs,:);

% adding pure boise features
nbnoise=18;
pbruit=1;
xapp=[xapp pbruit*randn(size(xapp,1),nbnoise)];
xtest=[xtest pbruit*zeros(size(xtest,1),nbnoise)];

%xapp=(xapp-ones(size(xapp,1),1)*mean(xapp))./(ones(size(xapp,1),1)*std(xapp));

d=2+nbnoise; % size of the data


%% linear group svm
% 
options.C = 1e2;

options.verbose= 1;%: print everything
options.log =1;%: log informations
options.nbitermax =1000 ;%: number of iterations max for optim
options.stopvarx=[1e-6];% : threshold for stopping on relative clasifier changes
options.stopvarj=[1e-12];% : threshold for stopping on relative cost changes


options.norm=2;% regularization type {1,2,[1,2],Inf,'trace'}

%options.groups=[1:d] % l1
options.groups=ceil([1:d]/2) % features grouped by 2

% Fista optimization parameter
options.nu=10;
options.L0=1;

tic 
[svm1,obj,LOG]=glgroupsvmclass(xapp,yapp,options)
toc


% prediction

%[ypred] = svmval2(xtest,svm1);
%ypred = reshape(ypred,nn,nn);


% visualisation

% figure(1)
% plot(svm1.w, 'DisplayName', 'svm.w', 'YDataSource', 'svm.w'); figure(gcf)
% title('classifier coefficients')
% figure(2)
% plot(log(LOG.J))
% title('Cost')

%% linear adaptive group svm
% 
options.C = 1e2;

options.verbose= 1;%: print everything
options.log =1;%: log informations
options.nbitermax =100 ;%: number of iterations max for optim
options.stopvarx=[1e-6];% : threshold for stopping on relative clasifier changes
options.stopvarj=[1e-12];% : threshold for stopping on relative cost changes


options.stopvarx2=[1e-3];% : threshold for stopping on F changes
options.nbitermax2 =10 ;%: number of iteration max for revweighting


options.norm=2;

%options.groups=[1:d]%ones(10,1)%ones(10,1)%1:10
%options.groups=ceil(3*rand(d,1));
options.nu=10;
options.L0=1;

tic 
[svma,obj,LOG]=algroupsvmclass(xapp,yapp,options)
toc

%[ypred] = svmval2(xtest,svm1);
%ypred = reshape(ypred,nn,nn);



% 
% figure(2)
% plot(svm1.w, 'DisplayName', 'svm.w', 'YDataSource', 'svm.w'); figure(gcf)
% title('classifier coefficients')
% figure(2)
% plot(log(LOG.J))
% title('Cost')




%% classifier vizualisation

figure(2)
plot(svm1.w, 'b'); 
hold on
plot(svma.w,'r');
hold off
title('classifier coefficients')
legend('GSVM','GSVMa')

