% test of the different MTL methods...


clear all
close all


addpath(genpath('.'))

%% Data creation

nbtask=10;
nbnoise=18;
nbapp=1000;
nbtest=0;
sigma=0.2;


seed=1985 % best year ever
rand('state',seed);
randn('state',seed);

for i=1:nbtask


    [xapp,yapp,xtest,ytest,xtest1,xtest2]=datasets('gaussian',nbapp,nbtest,sigma);
    %------- Building a 2D Grid for function evaluation
    %-------------------------
    
    
    
    % randomly permutes examples
    idxs=randperm(length(yapp));
    yapp=yapp(idxs);
    xapp=xapp(idxs,:);
    
    %reverse feature 2 for half of the tasks
    if rand(1)>.5
        xapp(:,2)=- xapp(:,2);
        xtest(:,2)=- xtest(:,2);
    end
    
    % adding pure boise features
    
    pbruit=1;
    X{i}=[xapp pbruit*randn(size(xapp,1),nbnoise)];
    Y{i}=yapp;
    
    Xte{i}=[xtest pbruit*zeros(size(xtest,1),nbnoise)];
    Yte{i}=ytest;
end
%xapp=(xapp-ones(size(xapp,1),1)*mean(xapp))./(ones(size(xapp,1),1)*std(xapp));

d=2+nbnoise; % size of the data




%% linear group svm
% 
options.C = 3e2;
options.reg_sim=0; % weight for similarity promoting term (var)


options.verbose= 1;%: print everything
options.log =1;%: log informations
options.nbitermax =1000 ;%: number of iterations max for optim
options.stopvarx=[1e-5];% : threshold for stopping on relative clasifier changes
options.stopvarj=[1e-6];% : threshold for stopping on relative cost changes

options.norm=2;


% Fista optimization parameter
options.nu=100;
options.L0=1;

% creation of mtl groups
groups=ceil((1:size(X{1},2))/2);
options.groups=cell(0);
for i=1:nbtask
    options.groups{i}=groups;
end 
options.backtrack=0;

tic
[svm,obj,LOG]=mtlgroupsvmclass(X,Y,options);
toc

%Ypred=mtlval(Xte,svm);

%prec=get_precision(Yte,Ypred)


%% full svm...

options.C = 100;
options.kernel='linear'
options.verbose= 1;%: print everything


 [Xfull,Yfull]=get_full_data(X,Y);
 [Xtefull,Ytefull]=get_full_data(Xte,Yte);
 

tic
[svm,LOG]=svmclass2(Xfull,Yfull,options)
toc

%Ypred=svmval2(Xtefull,svm);

%prec=get_precision(Ytefull,Ypred)






