function [X,Y,Xval,Yval,Xte,Yte,info]=loadUAM(opts,i)


if nargin<2
    i=0;
end

if ~isfield(opts,'props'), opts.props=[0.66 0 0.33]; end
if ~isfield(opts,'prop_classes'), opts.prop_classes=0; end
% uampath='/home/flam/MATLAB/data/P300uam/p300_database';
% addpath(uampath)

opts.props=opts.props/sum(opts.props);

if isfield(opts,'nbpts')
nbpts=opts.nbpts;
idx=floor(cumsum([1 nbpts]));
else
    props=opts.props;
    nbpts=[0 0 0 0];
    idx=[];
end

%idx(1)=1;
      
seed=i;
rand('seed',seed)


if opts.prop_classes==0
    
    
for i=1:length(opts.tasks)
    
    t=opts.tasks(i);
    

    [Xin,Yin]=load_uam_data(t);
    
    idxperm=randperm(length(Yin));
    Xin=Xin(idxperm,:);
    Yin=Yin(idxperm,:);
    
    if nbpts(3)==-1
        idx(4)=length(Yin);
    end
    
    info.nbpts(i)=length(Yin);
    
    if ~isfield(opts,'nbpts')
        nbmax=length(Yin);
         idx=floor(nbmax*cumsum([0 props]));
         idx(1)=1;
    end
    
X{i}=Xin(idx(1):idx(2)-1,:);
Y{i}=Yin(idx(1):idx(2)-1,:);
Xval{i}=Xin(idx(2):idx(3)-1,:);
Yval{i}=Yin(idx(2):idx(3)-1,:);
Xte{i}=Xin(idx(3):idx(4)-1,:);
Yte{i}=Yin(idx(3):idx(4)-1,:);

end

else
    
    idx=floor(idx/2);
    idx(1)=1;
    
    
    idxp=idx;
    idxn=idx;
    
for i=1:length(opts.tasks)
    
    t=opts.tasks(i);
    

    [Xin,Yin]=load_uam_data(t);
    
    Xp=Xin(Yin>0,:);
    Xn=Xin(Yin<0,:);
    
    Yp=Yin(Yin>0,:);
    Yn=Yin(Yin<0,:);
    
    idxpermp=randperm(length(Yp));
    idxpermn=randperm(length(Yp));
    Xp=Xp(idxpermp,:);
    Yp=Yp(idxpermp,:);    
    Xn=Xn(idxpermn,:);
    Yn=Yn(idxpermn,:);
    
    if nbpts(3)==-1
        idxn(4)=length(Yn);
        idxp(4)=length(Yp);
    end
    
    info.nbpts(i)=length(Yin);
    
    if ~isfield(opts,'nbpts')
        nbmax=length(Yin);
         idx=floor(nbmax*cumsum([0 props]));
         idx(1)=1;
    end
    
X{i}=[Xp(idxp(1):idxp(2)-1,:);Xn(idxn(1):idxn(2)-1,:)];
Y{i}=[Yp(idxp(1):idxp(2)-1,:);Yn(idxn(1):idxn(2)-1,:)];
Xval{i}=[Xp(idxp(2):idxp(3)-1,:);Xn(idxn(2):idxn(3)-1,:)];
Yval{i}=[Yp(idxp(2):idxp(3)-1,:);Yn(idxn(2):idxn(3)-1,:)];
Xte{i}=[Xp(idxp(3):idxp(4)-1,:);Xn(idxn(3):idxn(4)-1,:)];
Yte{i}=[Yp(idxp(3):idxp(4)-1,:);Yn(idxn(3):idxn(4)-1,:)];

end
    
    
end

