% testqps


%lassification 
%   Comparing Gaussian and polynomial Kernels 
%
%


clear all
close all

%%
%
%   Creating Data
%
seed=1985
rand('state',seed);
randn('state',seed);

nbapp=200;
nn=20;
nbtest=nn*nn;
sigma=0.5;
[xapp,yapp,xtest,ytest,xtest1,xtest2]=datasets('gaussian',nbapp,nbtest,sigma);
%------- Building a 2D Grid for function evaluation -------------------------
[xtest1 xtest2]  = meshgrid([-1:.05:1]*3.5,[-1:0.05:1]*3); 
nn = length(xtest1); 
xtest = [reshape(xtest1 ,nn*nn,1) reshape(xtest2 ,nn*nn,1)]; 

idxs=randperm(length(yapp));

yapp=yapp(idxs);
xapp=xapp(idxs,:);

nbnoise=0;
pbruit=1;
xapp=[xapp pbruit*randn(size(xapp,1),nbnoise)];
xtest=[xtest pbruit*zeros(size(xtest,1),nbnoise)];


%% biclasse

options.lambda = 1e-10;  
options.C = 1e3;
options.kernel='gaussian';
options.kerneloption=1;
options.verbose=1;
options.solver=7;
options.multiclass=0;
options.adaptiveC=1;

%options.w=

options.stopvarj=1e-8;
options.nbitermax=10000

tic 
[svm,obj]=svmclass2(xapp,yapp,options)
toc

[ypred] = svmval2(xtest,svm);
ypred = reshape(ypred,nn,nn); 

%%
%
%               plotting
%

figure(1); 
clf; 
 h1=plot(xapp(yapp==1,1),xapp(yapp==1,2),'+r'); hold on
h2=plot(xapp(yapp==-1,1),xapp(yapp==-1,2),'+b');
contour(xtest1,xtest2,ypred);%,[-1 0 1]

h3=plot(svm.xsup(:,1),svm.xsup(:,2),'ok'); 


